package polyglot.ext.ibex.lr;

import polyglot.ext.ibex.types.*;
import polyglot.util.*;
import java.util.*;

abstract class GLRSymbol {
    String name;
    int index;

    GLRSymbol(String name, int index) {
        this.name = name;
        this.index = index;
    }

    public String name() { return name; }
    public int index() { return index; }

    abstract Set first();
    abstract boolean isNullable();

    public boolean equals(Object o) {
        if (o instanceof GLRSymbol) {
            GLRSymbol s = (GLRSymbol) o;
            return index == s.index;
        }
        return false;
    }

    public int hashCode() {
        return index;
    }

    public String toString() {
        return name; //  + "@" + index;
    }
}
