package polyglot.ext.polyj.ast;

import polyglot.ast.*;
import polyglot.types.*;

import polyglot.ext.polyj.types.*;

import java.util.*;

/**
 * Generalization of the Method and Constructor subclasses.
 */
public interface ProcedureConstraint extends Node {
    
    /**
     * Returns the <code>flags</code> modifing this node.
     */
    public Flags flags();
    
    /**
     * Returns the name of this this method.
     */
    public String name();

    /**
     * Returns the parameter of this method as position <code>pos</code>.
     */
    public TypeNode getFormalParameterTypeAt(int pos);
    
    /**
     * Returns the List of formal parameters.
     */
    public List formals();

    /**
     * Returns the exception at position <code>pos</code> in the exception list.
     */
    public TypeNode getExceptionAt(int pos);

    /**
     * Return the list of exceptions.
     */
    public List exceptions();
    
    /**
     * Convert this into a ProcedureInstance contained by the given ParamType.
     */
    public ProcedureInstance toInstance(ParamType param);
    
}