package polyglot.ext.polyj.ast;

import polyglot.ast.*;
import polyglot.types.*;
import polyglot.visit.*;
import polyglot.util.*;

import polyglot.ext.jl.ast.*;

public class TypeParam_c extends Node_c implements TypeParam
{
    protected TypeNode typeNode;

    public TypeParam_c( Position pos, TypeNode typeNode) {
        super( pos);
        this.typeNode = typeNode;
    }

    public TypeNode typeNode() {
        return typeNode;
    }

    public TypeParam typeNode(TypeNode typeNode) {
        TypeParam_c n = (TypeParam_c) copy();
        n.typeNode = typeNode;
        return n;
    }

    public Object parameter() {
        return typeNode.type();
    }
    
    public String toString() {
        return typeNode.toString();
    }

    protected TypeParam_c reconstruct(TypeNode typeNode) {
        if (typeNode != this.typeNode) {
            TypeParam_c n = (TypeParam_c) copy();
            n.typeNode = typeNode;
            return n;
        }
        return this;
    }
    
    public Node visitChildren(NodeVisitor v) {
        TypeNode newTypeNode = (TypeNode) visitChild(typeNode, v);
        return reconstruct(newTypeNode);
    }
    
    public void prettyPrint(CodeWriter w, PrettyPrinter pp) {
        print(typeNode, w, pp);
    }

    public void translate(CodeWriter w, Translator tr) {
        // do nothing
    }
}
