package polyglot.ext.polyj.types.proxy;

/**
 * Superclass for proxies for byte, char, short, and int;
 * i.e., all numeric types smaller than long.
 */
public abstract class Int extends IntOrLong {
    public abstract IntProxy negate();
    public abstract IntProxy abs();
    
    public abstract IntProxy add(Int n);
    public abstract LongProxy add(LongProxy n);
    public abstract FloatProxy add(FloatProxy n);
    public abstract DoubleProxy add(DoubleProxy n);
    
    public abstract IntProxy subtract(Int n);
    public abstract LongProxy subtract(LongProxy n);
    public abstract FloatProxy subtract(FloatProxy n);
    public abstract DoubleProxy subtract(DoubleProxy n);
    
    public abstract IntProxy multiply(Int n);
    public abstract LongProxy multiply(LongProxy n);
    public abstract FloatProxy multiply(FloatProxy n);
    public abstract DoubleProxy multiply(DoubleProxy n);
    
    public abstract IntProxy divide(Int n);
    public abstract LongProxy divide(LongProxy n);
    public abstract FloatProxy divide(FloatProxy n);
    public abstract DoubleProxy divide(DoubleProxy n);
    
    public abstract IntProxy mod(Int n);
    public abstract LongProxy mod(LongProxy n);
    public abstract FloatProxy mod(FloatProxy n);
    public abstract DoubleProxy mod(DoubleProxy n);
        
    public abstract IntProxy min(Int n);
    public abstract LongProxy min(LongProxy n);
    public abstract FloatProxy min(FloatProxy n);
    public abstract DoubleProxy min(DoubleProxy n);
    
    public abstract IntProxy max(Int n);
    public abstract LongProxy max(LongProxy n);
    public abstract FloatProxy max(FloatProxy n);
    public abstract DoubleProxy max(DoubleProxy n);
    
    public abstract IntProxy not();
    
    public abstract IntProxy and(Int b);
    public abstract LongProxy and(LongProxy b);
    
    public abstract IntProxy or(Int b);
    public abstract LongProxy or(LongProxy b);
    
    public abstract IntProxy xor(Int b);
    public abstract LongProxy xor(LongProxy b);
}
